package org.objectquery.jpatutorial.business;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.objectquery.ObjectQuery;
import org.objectquery.generic.GenericObjectQuery;
import org.objectquery.jpaobjectquery.JPAObjectQuery;
import org.objectquery.jpatutorial.domain.Person;

public class BusinessClass {

	public static void main(String[] args) {

		EntityManagerFactory factory = Persistence.createEntityManagerFactory("test");
		EntityManager manager = factory.createEntityManager();

		try {
			manager.getTransaction().begin();

			Person p = new Person();
			p.setName("jhon");
			p.setSurname("doe");

			manager.persist(p);

		} finally {
			manager.getTransaction().commit();
		}

		try {

			manager.getTransaction().begin();

			ObjectQuery<Person> personQuery = new GenericObjectQuery<Person>(Person.class);

			personQuery.eq(personQuery.target().getName(), "jhon");

			List<Person> persons = JPAObjectQuery.buildQuery(personQuery, manager).getResultList();

			System.out.println(persons.size());
			System.out.println(persons.get(0).getName());
			System.out.println(persons.get(0).getSurname());

		} finally {
			manager.getTransaction().commit();
		}

	}

}
